
EnableExplicit

XIncludeFile "CT_BarChart.pbi"

Enumeration
   #WIN
   #CVA
EndEnumeration
#CVAx = 10
#CVAy = 10
#CVAw = 1000

Procedure MainWindow_Create()
   If OpenWindow(#WIN, 0, 0, #CVAw, #CVAw/1.6, "CanvasGadget", #PB_Window_MaximizeGadget|#PB_Window_ScreenCentered|#PB_Window_SizeGadget)
      CanvasGadget(#CVA, #CVAx, #CVAY, WindowWidth(#WIN)-20, WindowHeight(#WIN)-20, #PB_Canvas_Border)
   EndIf
EndProcedure

Procedure.i MainChart_Create()
   Protected pID.i
   
   pID = ctBarChart_New(#CVA)
   ctBarChart_xRasterPitch(10)
   ctBarChart_Nachkomma  (0)
   ctBarChart_yKoordinate(2000, 4100)
   ctBarChart_xKoordinate(5000, 8000)
   ;ctBarChart_Invers()
   ctBarChart_xRasterInfo("10.08.2011|08:00; 11.08.2011|08:00; 12.08.2011|08:00")
   ctBarChart_Titel ("Test")
   ctBarChart_xTitel("[Zeitpunkte]")
   ctBarChart_yTitel("[Byte]")
   ctBarChart_ChartColor(#Black)
   ProcedureReturn pID
EndProcedure

Procedure Data_Load(vID.a, *vData.ctBarChart_List, vColor.i)
   With *vData
      \xCount = vID
      \color = vColor
      AddElement(\y()):\y() = Random(2100) + 2000
      AddElement(\y()):\y() = Random(2100) + 2000
      AddElement(\y()):\y() = Random(2100) + 2000
   EndWith
EndProcedure

Procedure Main()
   Protected n.i, pChartID.i, pEvent.i, pQuit.a,pX.s, pY.s
   Protected pChart_01.ctBarChart_List
   Protected pChart_02.ctBarChart_List
   Protected pChart_03.ctBarChart_List
   
   MainWindow_Create()
   pChartID = MainChart_Create()
   Data_Load(1, @pChart_01, #Yellow)
   Data_Load(2, @pChart_02, #Red)
   Data_Load(3, @pChart_03, #Gray)
   
   Repeat
      pEvent = WaitWindowEvent()
      Select pEvent
         Case #PB_Event_CloseWindow: pQuit = #True
         Case #PB_Event_SizeWindow
            ResizeGadget(#CVA, #PB_Ignore, #PB_Ignore, WindowWidth(#WIN)-20, WindowHeight(#WIN)-20)
            ctBarChart_FontSize(GadgetWidth(#CVA)/100)
            ctBarChart_Present(3)
            ctBarChart_DrawBar(@pChart_01)
            ctBarChart_DrawBar(@pChart_02)
            ctBarChart_DrawBar(@pChart_03)
         Case #PB_Event_Gadget   
            If (EventGadget()=#CVA) And (EventType()=#PB_EventType_RightButtonDown)
               pY = StrF(ValF(ctBarChart_yPosition(GetGadgetAttribute(#CVA, #PB_Canvas_MouseY))), 1)
               If pY
                  MessageRequester("InfoBox", "Y/Byte = " + pY)
               EndIf
            EndIf
      EndSelect
   Until pQuit
EndProcedure

Main()
End
  