; Balken - Diagrammdarstellung
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;{- Konstanten

#ctBarChart_Date = -12
#ctBarChart_Time = -24

;} EndKonstanten

;{- Variablen

Structure BarChart_Format
   ID.i
   BarCount.a
   xRaster_Info.s
   xRaster_Pos.i
   xRaster_Len.i
   xTeilung.b 
   xRight_Pos.i
   xLeft_Pos.i
   xLeft.f
   xRight.f
   xFontSize.f
   xTitle.s
   yRaster_Pos.i
   yRaster_Len.i
   yTeilung.b
   yNachkomma.b
   yDown_Pos.i
   yUp_Pos.i
   yDown.f
   yUp.f
   yFontSize.f
   yTitle.s
   Raster_Color.i
   Rahmen_Color.i
   Chart_Color.i
   Back_Color.i
   Front_Color.i
   Title.s
   DateForm.s
   TimeForm.s
EndStructure

Structure ctBarChart_List
   List y.f()
   xCount.a
   Color.i
EndStructure

NewList ct_BarChart.BarChart_Format()

;} EndVariablen

;{- Declare

Declare.i ctBarChart_New(vID.i = #PB_Any)
Declare   ctBarChart_xRasterInfo(vText.s)
Declare   ctBarChart_Present(vBarCount.a = 1)
Declare   ctBarChart_Invers(vFlag.a = #True)
Declare   ctBarChart_Active(vList.i)
Declare   ctBarChart_Close(vList.i)
Declare   ctBarChart_Delete()
Declare   ctBarChart_RasterLen(vX.a = 86, vY.a = 76)
Declare     BarChart_Raster()
Declare     BarChart_Inscription()
Declare   ctBarChart_yKoordinate(vMin.f, vMax.f)
Declare   ctBarChart_RasterColor(vColor.i)
Declare   ctBarChart_RahmenColor(vColor.i)
Declare   ctBarChart_ChartColor(vColor.i)
Declare   ctBarChart_BackColor(vColor.i)
Declare   ctBarChart_FrontColor(vColor.i)
Declare   ctBarChart_RasterPitch(vTeilung.i)
Declare.b ctBarChart_xRasterPitch(vTeilung.i = #PB_Any)
Declare.b ctBarChart_yRasterPitch(vTeilung.i = #PB_Any)
Declare.b ctBarChart_Nachkomma(vNK.b = #PB_Any)
Declare   ctBarChart_FontSize(vFontSize.f)
Declare.f ctBarChart_xFontSize(vFontSize.f = #Null)
Declare.f ctBarChart_yFontSize(vFontSize.f = #Null)
Declare.s ctBarChart_DateForm (vMaske.s = #NULL$)
Declare.s ctBarChart_TimeForm (vMaske.s = #NULL$)
Declare.i   BarChart_xPosition(vX.f)
Declare.i   BarChart_yPosition(vY.f)
Declare   ctBarChart_DrawBar(*vBar.ctBarChart_List)
Declare.s ctBarChart_yPosition(vYy.i)
Declare   ctBarChart_Titel(vText.s)
Declare   ctBarChart_xTitel(vText.s)
Declare   ctBarChart_yTitel(vText.s)

;} EndDeclare

;{- InternProceduren

;Diagrammraster [Set|Intern]
Procedure BarChart_Raster()
   Shared ct_BarChart()
   Protected pY.i, pY1.i, pY2.i, pYs.i
   Protected pX.i, pX1.i, pX2.i, pXs.i
   
   With ct_BarChart()
      If (\ID=#PB_Any): ProcedureReturn: EndIf
      pX1 = GadgetWidth(\ID)  * \xRaster_Pos / 100       : \xLeft_Pos  = pX1
      pX2 = GadgetWidth(\ID)  * \xRaster_Len / 100 + pX1 : \xRight_Pos = pX2
      pXs = pX2 - pX1
      If (\xTeilung>#False)
         pXs = (pX2 - pX1) / \xTeilung
         pX2 = pX1 + pXs * \xTeilung : \xRight_Pos = pX2
      EndIf
      pY1 = GadgetHeight(\ID) * \yRaster_Pos / 100       : \yUp_Pos    = pY1
      pY2 = GadgetHeight(\ID) * \yRaster_Len / 100 + pY1 : \yDown_Pos  = pY2
      pYs = pY2 - pY1
      If (\yTeilung>#False)
         pYs = (pY2 - pY1) / \yTeilung
         pY2 = pY1 + pYs * \yTeilung : \yDown_Pos  = pY2
      EndIf
      If StartDrawing(CanvasOutput(\ID))
         Box(0, 0, GadgetWidth(\ID), GadgetHeight(\ID), \Back_Color)
         Box(\xLeft_Pos, \yDown_Pos, (\xRight_Pos-\xLeft_Pos), (\yUp_Pos-\yDown_Pos), \Chart_Color)
         pY = pY1
         Repeat  
            For pX=pX1-10 To pX2 Step 2
               Plot (pX, pY,  \Raster_Color)
            Next pX
            pY + pYs
         Until (pY=pY2+pYs)
         pX = pX1
         Repeat
            For pY=pY1 To pY2+10 Step 2
               Plot (pX, pY, \Raster_Color)
            Next pY
            pX + pXs
         Until (pX=pX2+pXs)
         If Not (\Rahmen_Color=#PB_Any)
            If \xTeilung: pXs * \xTeilung: EndIf
            If \yTeilung: pYs * \yTeilung: EndIf
            Line(pX1, pY2, pXs, 001, \Rahmen_Color)    
            Line(pX1, pY1, pXs, 001, \Rahmen_Color)    
            Line(pX1, pY1, 001, pYs, \Rahmen_Color)    
            Line(pX1+pXs, pY1, 001, pYs, \Rahmen_Color)  
         EndIf
         StopDrawing()
      EndIf
      BarChart_Inscription()
   EndWith         
EndProcedure

;Diagrammbeschriftung [Set|Intern]
Procedure BarChart_Inscription()
   Shared ct_BarChart()
   Protected pN.i, pFont.i, pFontID.i, pLen.f, pFlag.i
   Protected pX1s.i, pX1.i, pX2.f, pX2s.f, pXv.s, pXLeft.i
   Protected pY1s.i, pY1.i, pY2.f, pY2s.f, pYv.s, pYDown.i
   
   With ct_BarChart()
      pFont   = (GadgetWidth(\ID) * \xRaster_Len) / (3000 - \yUp_Pos * 2)
      pFontID = LoadFont(#PB_Any, "Arial", pFont)
      If StartDrawing(CanvasOutput(\ID))
         FrontColor (\Front_Color)
         DrawingMode(#PB_2DDrawing_Transparent)
         If pFontID: DrawingFont(FontID(pFontID)): EndIf
         pX1 = (\xRight_Pos + \xLeft_Pos) / 2 - Len(\Title) * pFont / 3.2
         pY1 = \yUp_Pos - TextHeight(\Title) ;(pFont * 1.8)         
         DrawText(pX1, pY1, \Title)
         StopDrawing()
         FreeFont(pFontID)
      EndIf
      Select \yNachkomma
         Case #ctBarChart_Date: pFlag = 1000 + Len(RemoveString(\DateForm, "%")) * 800
         Case #ctBarChart_Time: pFlag = 1000 + Len(RemoveString(\TimeForm, "%")) * 800
         Case #ctBarChart_Date|#ctBarChart_Time
            pFlag = 1000 + Len(RemoveString(\DateForm, "%")) * 800 
            If \yTeilung>10: \yTeilung = 10: EndIf
         Default: pFlag = 5800
      EndSelect
      If \yFontSize: pFont = \yFontSize: Else: pFont = GadgetWidth(\ID) * \xRaster_Len / pFlag: EndIf
      pFontID = LoadFont(#PB_Any, "Arial", pFont)
      If StartDrawing(CanvasOutput(\ID))
         FrontColor (\Front_Color)
         DrawingMode(#PB_2DDrawing_Transparent)
         If pFontID: DrawingFont(FontID(pFontID)): EndIf      
         pY1s  = (\yUp_Pos - \yDown_Pos) / \yTeilung
         pY1  = \YDown_Pos - pFont * 0.8    
         pY2  = \YDown
         If (\yNachkomma=#ctBarChart_Date|#ctBarChart_Time): pY1 - TextHeight("A") / 2: EndIf
         pY2s = (\YUp - \yDown) / \yTeilung
         Repeat            
            Select \yNachkomma
               Case #ctBarChart_Date: pYv = FormatDate(\DateForm, pY2)
               Case #ctBarChart_Time: pYv = FormatDate(\TimeForm, pY2)
               Case #ctBarChart_Date|#ctBarChart_Time: pYv = FormatDate(\DateForm, pY2)
               Default: pYv = StrF(pY2, \yNachkomma)
            EndSelect
            pX1 =\xLeft_Pos - TextWidth(pYv + Space(2))
            DrawText(pX1, pY1, pYv)
            If (\yNachkomma=#ctBarChart_Date|#ctBarChart_Time)
               pYv = FormatDate(\TimeForm, pY2)
               pX1 = \xLeft_Pos - TextWidth(pYv + Space(2))
               DrawText(pX1, pY1 + TextHeight(pYv), pYv)
            EndIf
            pY1 + pY1s: pY2 + pY2s
         Until (pY1<=(\yUp_Pos + pY1s))
         pX1 = (GadgetWidth(\ID) * 0.01) - (TextWidth(\yTitle) * 0.1)
         pY1 = GadgetHeight(\ID) - (GadgetHeight(\ID) - TextWidth(\yTitle)) / 2 
         DrawRotatedText(pX1, pY1, \yTitle, 90)
         StopDrawing()
      EndIf
      
      pFlag = 5800
      If \xFontSize: pFont = \xFontSize: Else: pFont = GadgetWidth(\ID) * \xRaster_Len / pFlag: EndIf
      pFontID = LoadFont(#PB_Any, "Arial", pFont)
      If StartDrawing(CanvasOutput(\ID))
         FrontColor (\Front_Color)
         DrawingMode(#PB_2DDrawing_Transparent)
         If pFontID: DrawingFont(FontID(pFontID)): EndIf  
         pX2  = \xLeft_Pos
         pX2s = (\xRight_Pos - \xLeft_Pos) / \xTeilung
         pN = 1
         Repeat 
            pXv  = StringField(\xRaster_Info, pN, Chr(59))
            pY1  = \yDown_Pos + TextHeight(pXv) * 0.5
            If FindString(pXv, Chr(124))
               For pFlag = 1 To (CountString(pXv, Chr(124))+1)
                  pX1  = pX2 + (pX2s - TextWidth(StringField(pXv, pFlag, Chr(124)))) / 2   
                  DrawText(pX1, pY1, StringField(pXv, pFlag, Chr(124)))
                  pY1 + TextHeight(pXv)
               Next pFlag
            Else
               pX1  = pX2 + (pX2s - TextWidth(pXv)) / 2
               DrawText(pX1, pY1 + TextHeight(pXv), pXv)
            EndIf
            pN  + 1: pX2 + pX2s
         Until (pN>\xTeilung)
         pX1 = \xLeft_Pos + (\xRight_Pos - \xLeft_Pos - TextWidth(\xTitle)) / 2
         pY1 = GadgetHeight(\ID) - (GadgetHeight(\ID) * 0.01 + TextHeight(\xTitle) * 1.5)
         DrawText(pX1, pY1, \xTitle)
         StopDrawing()
         FreeFont(pFontID)
      EndIf
      
   EndWith
EndProcedure

;Konvertierung Punktkoordinate X-Achse [Set|Get|Intern]
Procedure.i BarChart_xPosition(vX.f)
   Shared ct_BarChart()
   Protected pPixel.i, pOffset.f, pWidth.f, pFactor.f, pPos.i
   
   With ct_BarChart()
      pPixel  = \xRight_Pos - \xLeft_Pos
      pOffset = vX - \xLeft
      pWidth  = \xRight - \xLeft
      pFactor = pOffset / pWidth
      pPos    = \xLeft_Pos + pPixel * pFactor
   EndWith
   ProcedureReturn pPos
EndProcedure

;Konvertierung Punktkoordinate Y-Achse [Set|Get|Intern]
Procedure.i BarChart_yPosition(vY.f)
   Shared ct_BarChart()
   Protected pPixel.i, pOffset.f, pHeight.f, pFactor.f, pPos.i
   
   With ct_BarChart()
      pPixel  = \yUp_Pos - \yDown_Pos
      pOffset = vY - \yDown
      pHeight = \yUp - \yDown
      pFactor = pOffset / pHeight
      pPos    = \yDown_Pos + pPixel * pFactor
   EndWith
   ProcedureReturn pPos
EndProcedure

;} EndInternProceduren

;{- ExternProceduren

;Erstellen eines neuen oder erneuern eines bestehenden Diagrammes [Set]
Procedure.i ctBarChart_New(vID.i = #PB_Any)                                             
   Shared ct_BarChart()

   With ct_BarChart() 
      If Not(vID=#PB_Any)
         AddElement(ct_BarChart())
         \ID = vID
         \Raster_Color = #Gray
         \Rahmen_Color = #Black
         \Chart_Color  = #White
         \Back_Color   = #White
         \Front_Color  = #Black
         \xTeilung     = 10
         \xLeft        = 0
         \xRight       = 1
         \yNachkomma   = 1
         \yTeilung     = 10
         \yDown        = 0
         \yUp          = 1
         \DateForm     = "%dd.%mm.%yyyy" 
         \TimeForm     = "%hh:%ii:%ss"
      EndIf
;Raster-Groesse, Raster-Position  in  %  der Haupt-Fenster-Groesse.
      \xRaster_Pos  = 10
      \xRaster_Len  = 86
      \yRaster_Pos  = 10
      \yRaster_Len  = 76
   EndWith
   If Not(vID=#PB_Any): ProcedureReturn (ListSize(ct_BarChart()) - 1): EndIf
EndProcedure

;Diagrammspalteninfo und Anzahl[Set]
Procedure ctBarChart_xRasterInfo(vText.s)
   Shared ct_BarChart()
   
   With ct_BarChart()
      \xRaster_Info = vText
      \xTeilung = CountString(vText, Chr(59)) + 1
   EndWith
EndProcedure

;Anzeigen, Prsentieren [Set]
Procedure ctBarChart_Present(vBarCount.a = 1)
   Shared ct_BarChart()

   BarChart_Raster()
   ct_BarChart()\BarCount = (vBarCount + 2)
EndProcedure

;Schwarz-Wei/ Wei-Schwarz Darstellung [Set]
Procedure ctBarChart_Invers(vFlag.a = #True)
   Shared ct_BarChart()
   
   With ct_BarChart() 
      If vFlag
         \Raster_Color = #Gray
         \Rahmen_Color = #White
         \Chart_Color  = #Black
         \Back_Color   = #Black
         \Front_Color  = #White
      Else
         \Raster_Color = #Gray
         \Rahmen_Color = #Black
         \Chart_Color  = #White
         \Back_Color   = #White
         \Front_Color  = #Black
      EndIf
   EndWith
EndProcedure

;Aktivieren eines bestehenden Diagrammes [Set]
Procedure ctBarChart_Active(vList.i)
   Shared ct_BarChart()
   
   SelectElement(ct_BarChart(), vList)
EndProcedure

;Lschen eines bestehenden Diagrammes [Set]
Procedure ctBarChart_Close(vList.i)
   Shared ct_BarChart()
   
   SelectElement(ct_BarChart(), vList)
   ClearStructure(@ct_BarChart(), BarChart_Format)
   ct_BarChart()\ID = #PB_Any
EndProcedure

;Lschen aller bestehender Diagramme [Set]
Procedure ctBarChart_Delete()
   Shared ct_BarChart()
   
   ClearList(ct_BarChart())    
EndProcedure

;Raster-Groesse in % der Haupt-Fenster-Groesse [Set]
Procedure ctBarChart_RasterLen(vX.a = 86, vY.a = 76)
   Shared ct_BarChart()
   
   If (vX<90): ct_BarChart()\xRaster_Len = vX: EndIf
   If (vY<81): ct_BarChart()\yRaster_Len = vY: EndIf
EndProcedure

;Diagrammrasterfarbe [Set]
Procedure ctBarChart_RasterColor(vColor.i)
   Shared ct_BarChart()
   
   ct_BarChart()\Raster_Color = vColor
EndProcedure

;Diagrammrahmenfarbe [Set]
Procedure ctBarChart_RahmenColor(vColor.i)
   Shared ct_BarChart()
   
   ct_BarChart()\Rahmen_Color = vColor
EndProcedure

;Diagrammhintergrundfarbe [Set]
Procedure ctBarChart_ChartColor(vColor.i)
   Shared ct_BarChart()
   
   ct_BarChart()\Chart_Color = vColor
EndProcedure

;Hintergrundfarbe [Set]
Procedure ctBarChart_BackColor(vColor.i)
   Shared ct_BarChart()
   
   ct_BarChart()\Back_Color = vColor
EndProcedure

;Beschriftungsfarbe [Set]
Procedure ctBarChart_FrontColor(vColor.i)
   Shared ct_BarChart()
   
   ct_BarChart()\Front_Color = vColor
EndProcedure

;Rasterteilung XY-Achsen [Set]
Procedure ctBarChart_RasterPitch(vTeilung.i)
   Shared ct_BarChart()
   
   If (vTeilung=0): vTeilung = 1: EndIf
   ct_BarChart()\xTeilung = vTeilung
   ct_BarChart()\yTeilung = vTeilung
EndProcedure

;Rasterteilung X-Achse [Set|Get]
Procedure.b ctBarChart_xRasterPitch(vTeilung.i = #PB_Any)
   Shared ct_BarChart()
   
   If (vTeilung.i = #PB_Any)
      ProcedureReturn ct_BarChart()\xTeilung
   Else
      If (vTeilung=0): vTeilung = 1: EndIf
      ct_BarChart()\xTeilung = vTeilung
      ct_BarChart()\xRight   = vTeilung
   EndIf
EndProcedure

;Rasterteilung Y-Achse [Set|Get]
Procedure.b ctBarChart_yRasterPitch(vTeilung.i = #PB_Any)
   Shared ct_BarChart()
   
   If (vTeilung.i = #PB_Any)
      ProcedureReturn ct_BarChart()\yTeilung
   Else
      If (vTeilung=0): vTeilung = 1: EndIf
      ct_BarChart()\yTeilung = vTeilung
   EndIf
EndProcedure

;Beschriftungswert Min-Max der X-Achse [Set]
Procedure ctBarChart_xKoordinate(vMin.f, vMax.f)
   Shared ct_BarChart()
   
   ct_BarChart()\xLeft  = vMin
   ct_BarChart()\xRight = vMax
EndProcedure

;Beschriftungswert Min-Max der Y-Achse [Set]
Procedure ctBarChart_yKoordinate(vMin.f, vMax.f)
   Shared ct_BarChart()
   
   ct_BarChart()\yDown  = vMin
   ct_BarChart()\yUp    = vMax
EndProcedure

;Nachkomma der Y-Achsen [Set|Get]
Procedure.b ctBarChart_Nachkomma(vNK.b = #PB_Any)
   Shared ct_BarChart()
   
   If (vNK=#PB_Any)
      ProcedureReturn ct_BarChart()\yNachkomma
   Else
      ct_BarChart()\yNachkomma = vNK
   EndIf
EndProcedure 

;FontSize der XY-Achsen [Set]
Procedure ctBarChart_FontSize(vFontSize.f)
   Shared ct_BarChart()
   
   ct_BarChart()\xFontSize = vFontSize
   ct_BarChart()\yFontSize = vFontSize
EndProcedure

;FontSize der X-Achse [Set|Get]
Procedure.f ctBarChart_xFontSize(vFontSize.f = #Null)
   Shared ct_BarChart()
   
   If vFontSize
      ct_BarChart()\xFontSize = vFontSize
   Else
      ProcedureReturn ct_BarChart()\xFontSize
   EndIf      
EndProcedure

;FontSize der Y-Achse [Set|Get]
Procedure.f ctBarChart_yFontSize(vFontSize.f = #Null)
   Shared ct_BarChart()
   
   If vFontSize
      ct_BarChart()\yFontSize = vFontSize
   Else
      ProcedureReturn ct_BarChart()\yFontSize
   EndIf
EndProcedure

;DatumFormat (%dd.%mm.%yyyy) [Set|Get]
Procedure.s ctBarChart_DateForm (vMaske.s = #NULL$)
   Shared ct_BarChart()
   
   If vMaske
      ct_BarChart()\DateForm = vMaske
   Else
      ProcedureReturn ct_BarChart()\DateForm
   EndIf
EndProcedure

;ZeitFormat (%hh:%ii:%ss) [Set|Get]
Procedure.s ctBarChart_TimeForm (vMaske.s = #NULL$)
   Shared ct_BarChart()
   
   If vMaske
      ct_BarChart()\TimeForm = vMaske
   Else
      ProcedureReturn ct_BarChart()\TimeForm
   EndIf
EndProcedure

;Zeichnen von DiagrammBalken [Set]
Procedure ctBarChart_DrawBar(*vBar.ctBarChart_List)
   Shared ct_BarChart()
   Protected pBar.a, pX.i, pXs.i, pY.i, pYs.i
   
   With ct_BarChart()
      ForEach *vBar\y()
         pXs = (\xRight_Pos - \xLeft_Pos) / \xTeilung
         pX = (\xLeft_Pos + pXs * pBar) + (pXs / \BarCount * *vBar\xCount)
         If (*vBar\y()<ct_BarChart()\yDown) Or (*vBar\y()>ct_BarChart()\yUp)
            ProcedureReturn
         Else
            pY =  BarChart_yPosition(*vBar\y())
            pYs = BarChart_yPosition(\yDown) - pY
         EndIf
         If StartDrawing(CanvasOutput(\ID))
            Box(pX, pY, (pXs / \BarCount), pYs, *vBar\Color)
            StopDrawing()
         EndIf
         pBar + 1
      Next
    EndWith
EndProcedure

;Konvertierung Wert Y-Achse [Set|Get]
Procedure.s ctBarChart_yPosition(vY.i)
   Shared ct_BarChart()
   Protected pPixel.f, pOffset.f, pHeight.f, pFactor.f, pPos.f, pResult.s
   
   With ct_BarChart()
      If (vY<\yUp_Pos) Or (vY>\yDown_Pos): ProcedureReturn: EndIf
      pPixel  = \yUp_Pos - \yDown_Pos
      pHeight = \yUp - \yDown
      pFactor = (vY - \yDown_Pos) / pPixel
      pOffset = pHeight * pFactor
      pPos    = pOffset + \yDown
      Select \yNachkomma
         Case #ctBarChart_Date: pResult = FormatDate(\DateForm, pPos)
         Case #ctBarChart_Time: pResult = FormatDate(\TimeForm, pPos)
         Case #ctBarChart_Date|#ctBarChart_Time: pResult = FormatDate(\DateForm + Space(1) + \TimeForm, pPos)
         Default: pResult = StrF(pPos)
      EndSelect
   EndWith
   ProcedureReturn pResult
EndProcedure

;Diagrammberschrift [Set]
Procedure ctBarChart_Titel(vText.s)
   Shared ct_BarChart()
   
   ct_BarChart()\Title = vText
EndProcedure

;xAchsenbeschriftung [Set]
Procedure ctBarChart_xTitel(vText.s)
   Shared ct_BarChart()
   
   ct_BarChart()\xTitle = vText
EndProcedure

;yAchsenbeschriftung [Set]
Procedure ctBarChart_yTitel(vText.s)
   Shared ct_BarChart()
   
   ct_BarChart()\yTitle = vText
EndProcedure

;} EndExternProceduren
